<?php

add_action( 'admin_menu', 'def_admin' );
add_filter( 'admin_init', 'add_js' );

function add_js() {
    wp_enqueue_script( 'def-script', plugins_url('defender.js', __FILE__), array('jquery') );
}

function def_admin() {
    add_plugins_page('Defender', DEF, 'read', 'Defender', 'def_options');
}

function def_options() {
    if ( function_exists('current_user_can') && !current_user_can('manage_options') )
	die(__('access denied'));
        
    $countries = json_decode(file_get_contents(DEF_URL . '/codes.dat'), true);
    $hidden_field_name = 'def_submit_hidden';
    
    asort($countries);
       
    if( isset($_POST[ $hidden_field_name ]) && $_POST[ $hidden_field_name ] == 'Y' ) {
        $ret_list = trim($_POST["blacklisted"]);
        if (strlen($ret_list)) {
            if ( strpos($ret_list, ',') ) {
                $bl = explode(',', $_POST["blacklisted"]);
            }else{
                $bl = array($ret_list);
            }
            update_option("blacklisted", $bl);
        }
        
        update_option("redirect_to", $_POST["redirect_to"]);
        update_option("def_login", $_POST["def_login"]);
        
        ?><div class="updated"><p><strong><?php _e('Options saved.') ?></strong></p></div><?php
    }
        
    $blacklisted = get_option( "blacklisted" );
    
    $redirect = get_option( "redirect_to" );
    if (!$redirect) update_option( "redirect_to", "404" );
    
    $def_login = get_option( "def_login" );
    if (!$def_login) update_option( "def_login", "off" );
    
    $i=1;
    $white = "";
    $black = "";
    
    foreach($countries as $c_code => $country) {
        if ( in_array($c_code, $blacklisted) ) {
            $black .= '<option value="' . $c_code . '" data-idx="'. $i++ .'">' . $country . '</option>';
        }else{
            $white .= '<option value="' . $c_code . '" data-idx="'. $i++ .'">' . $country . '</option>';
        }
    }

    ?>
        <div class="wrap">
            <div id="icon-options-general" class="icon32"><br /></div><h2><?php echo esc_attr_e('Settings'); ?> - Defender</h2>
            <form name="form1" method="post" action="">
            <h3>Block countries</h3>
                <input type="hidden" name="<?php echo $hidden_field_name; ?>" value="Y">
                <input type="hidden" name="blacklisted" id="blacklisted" value="">
                <div style="position: relative; top: 0; width: 260px; display: inline-block;">
                    <h4 style="width: 100%; text-align: center;">Whitelisted countries</h4>
                    <select name="whitelist" id="whitelist" size="20" style="width: 100%; position: relative;" multiple>
                        <?php echo $white; ?>
                    </select>
                    <br />
                    <input type="button" name="add_country" id="add_country" class="button-primary" value="<?php esc_attr_e('Add') ?>" style="float: right;" />
                </div>
                
                <div style="position: relative; width: 260px; display: inline-block; top: 6px; left: 30px;">
                    <h4 style="width: 100%; text-align: center;">Blacklisted countries</h4>
                    <select name="blacklist" id="blacklist" size="20" style="width: 100%; position: relative;" multiple>
                        <?php echo $black; ?>
                    </select>
                    <br />
                    <input type="button" name="remove_country" id="remove_country" class="button-primary" value="<?php esc_attr_e('Remove') ?>" />
                </div>
                <br /><br />
                <p>
                    Add the countries you would like to blacklist from your website into the "Blacklisted countries" column above by selecting them and clicking "<?php esc_attr_e('Add') ?>".<br />
                    Removal from the "Blacklisted countries" column is the exact opposite procedure.
                </p>
                <div>
                    <h4>Redirect requests coming from users in the blacklisted countries to :</h4>
                    <label title="404"><input type="radio" name="redirect_to" value="404" <?php checked( '404', get_option( 'redirect_to' ) ); ?> /> <span>Wordpress 404 page</span></label><br>
                    <label title="403"><input type="radio" name="redirect_to" value="403" <?php checked( '403', get_option( 'redirect_to' ) ); ?> /> <span>Send a 403 Forbidden</span></label><br>
                    <label title="Custom"><input type="radio" name="redirect_to" value="600" <?php checked( '600', get_option( 'redirect_to' ) ); ?> /> <span>Create a custom page (edit the "<span style="font-weight: bold;">blocked.php</span>" file in the plugin directory)</span></label><br>
                </div>
                <br />
                <div>
                    <h4>Block Wordpress login page :</h4>
                    <label title="Block login page"><input type="checkbox" name="def_login" value="def_login" <?php checked( 'def_login', get_option( 'def_login' ) ); ?> /> <span>Block login page</span></label><br>
                    <p style="font-size: 11px;">Warning : This could lock you out from Wordpress if you blacklist your own country, on the other hand, leaving it unchecked does not block any users from the login page</p>
                </div>
                <br />
                <p class="submit">
                    <input type="submit" name="Submit" class="button-primary" value="<?php esc_attr_e('Save Changes') ?>" />
                </p>
                <p style="font-size: 11px;">
                    This plugin uses geoloaction based on the visitors IP-adress. No guarantees are given on it's accuracy !
                </p>
            </form>
        </div>
    <?php
}
?>