<?php
/*
Plugin Name: Defender
Plugin URI: http://played.no/
Description: Block users by country
Version: 1.0
Author: Played Interactive
Author URI: http://played.no
License: GPLv2 or later
*/

define('DEF_URL', plugin_dir_url( __FILE__ ));
define('DEF', 'Defender' );

if ( !function_exists( 'add_action' ) ) {
    echo "This is just a plugin ?";
    exit;
}

if ( is_admin() ) {
    require_once dirname( __FILE__ ) . '/admin.php';
}else{
    if ( in_array( $GLOBALS['pagenow'], array( 'wp-login.php', 'wp-register.php' ) ) ) { // we're at the login page
        if ( get_option( "def_login" ) == "def_login") {
            add_action('init', 'blockUsers', 1); // the option to block the user from the login page has been enabled
        }
    }else{
        add_action('init', 'blockUsers', 1); // block users if plugin is active and user is not admin, and page is not login.php
    }
}

    
function blockUsers() {
    if(!session_id()) {
        session_start();
    }
    
    if ( isset($_SESSION['user_country']) ) {
        $user_country = $_SESSION['user_country'];
    }else{
        $user_country  = getCountry();
        $_SESSION['user_country'] = $user_country;
    }

    $black_countries = get_option( "blacklisted" );
    
    if ($user_country && $user_country != "RD") {
        if ( in_array($user_country, $black_countries) ) {
            $re_to = trim( get_option( "redirect_to" ) );
            if ($re_to == '403') {
                header('HTTP/1.0 403 Forbidden');
                die();
            }else if ($re_to == '404') {
                add_action( 'parse_query', 'go_to_404' );
                function go_to_404( $wp_query ) {
                    header('HTTP/1.0 404 Error');
                    $wp_query->set_404();
                }
            }else{
                header('HTTP/1.0 403 Forbidden');
                include(DEF_URL . '/blocked.php');
                die();
            }
        }
    }
}

function getCountry() {
    if ( isset($_SERVER['HTTP_X_FORWARDED_FOR']) && strlen($_SERVER['HTTP_X_FORWARDED_FOR'] > 3)) {
        $ip = $_SERVER['HTTP_X_FORWARDED_FOR'];
    }else{
        $ip = $_SERVER['REMOTE_ADDR'];
    }
    $json = wp_remote_get( 'http://freegeoip.net/json/'.$ip );
    if ( 200 == $json['response']['code'] ) {
        $adress = json_decode( $json['body'] );
    }else{
        $adress = false;
    }
    return $adress && isset($adress->country_code) ? strtoupper($adress->country_code) : false;
}

?>